Index: /trunk/kernel/kern/process.c
===================================================================
--- /trunk/kernel/kern/process.c	(revision 656)
+++ /trunk/kernel/kern/process.c	(revision 657)
@@ -4,5 +4,5 @@
  * Authors  Ghassan Almaless (2008,2009,2010,2011,2012)
  *          Mohamed Lamine Karaoui (2015)
- *          Alain Greiner (2016,2017,2018,2019)
+ *          Alain Greiner (2016,2017,2018,2019,2020)
  *
  * Copyright (c) UPMC Sorbonne Universites
@@ -1103,9 +1103,9 @@
     xptr_t    xp;
 
-    // get reference process cluster and local pointer
+    // get target process cluster and local pointer
     process_t * process_ptr = GET_PTR( process_xp );
     cxy_t       process_cxy = GET_CXY( process_xp );
 
-// check client process is reference process
+// check target process is reference process
 assert( (process_xp == hal_remote_l64( XPTR( process_cxy , &process_ptr->ref_xp ) ) ),
 "client process must be reference process\n" );
@@ -1158,4 +1158,85 @@
 
 }  // end process_fd_register()
+
+/////////////////////////////////////////////
+void process_fd_remove( xptr_t    process_xp,
+                        uint32_t  fdid )
+{
+    pid_t       pid;           // target process PID 
+    lpid_t      lpid;          // target process LPID
+    xptr_t      iter_xp;       // iterator for list of process copies
+    xptr_t      copy_xp;       // extended pointer on process copy
+    process_t * copy_ptr;      // local pointer on process copy  
+    cxy_t       copy_cxy;      // process copy cluster identifier
+
+// check process_xp argument
+assert( (process_xp != XPTR_NULL), "process_xp argument cannot be XPTR_NULL");
+
+    // get target process cluster and local pointer
+    process_t * process_ptr = GET_PTR( process_xp );
+    cxy_t       process_cxy = GET_CXY( process_xp );
+
+    // get target process pid and lpid
+    pid  = hal_remote_l32( XPTR( process_cxy , &process_ptr->pid) );
+    lpid = LPID_FROM_PID( pid );
+
+    // get process descriptor in owner cluster and in reference cluster
+    xptr_t  owner_xp = hal_remote_l64( XPTR( process_cxy , &process_ptr->owner_xp ));
+    xptr_t  ref_xp   = hal_remote_l64( XPTR( process_cxy , &process_ptr->ref_xp   ));
+
+// check target process in in owner cluster 
+assert( (process_xp == owner_xp), "target process must be in owner process\n" );
+
+#if DEBUG_PROCESS_FD_REMOVE
+uint32_t    cycle = (uint32_t)hal_get_cycles();
+thread_t  * this  = CURRENT_THREAD;
+if( DEBUG_PROCESS_FD_REMOVE < cycle )
+printk("\n[%s] thread[%x,%x] enter for fdid %d in process %x / cycle %d\n",
+__FUNCTION__, this->process->pid, this->trdid, fdid, pid, cycle );
+#endif
+
+    // build extended pointers on list_of_copies root and lock (in owner cluster)
+    xptr_t copies_root_xp = XPTR( process_cxy , &LOCAL_CLUSTER->pmgr.copies_root[lpid] );
+    xptr_t copies_lock_xp = XPTR( process_cxy , &LOCAL_CLUSTER->pmgr.copies_lock[lpid] );
+ 
+    // get reference process cluster and local pointer
+    process_t * ref_ptr = GET_PTR( ref_xp );
+    cxy_t       ref_cxy = GET_CXY( ref_xp );
+
+    // build extended pointer on lock protecting reference fd_array
+    xptr_t fd_lock_xp = XPTR( ref_cxy , &ref_ptr->fd_array.lock );
+
+    // take lock protecting reference fd_array
+	remote_queuelock_acquire( fd_lock_xp );
+
+    // take the lock protecting the list of copies
+    remote_queuelock_acquire( copies_lock_xp );
+
+    // loop on list of process copies
+    XLIST_FOREACH( copies_root_xp , iter_xp )
+    {
+        // get pointers on process copy
+        copy_xp  = XLIST_ELEMENT( iter_xp , process_t , copies_list );
+        copy_ptr = GET_PTR( copy_xp );
+        copy_cxy = GET_CXY( copy_xp );
+
+        // release the fd_array entry in process copy
+        hal_remote_s64( XPTR( copy_cxy , &copy_ptr->fd_array.array[fdid] ), XPTR_NULL );
+    }
+
+    // release the lock protecting reference fd_array
+	remote_queuelock_release( fd_lock_xp );
+
+    // release the lock protecting the list of copies
+    remote_queuelock_release( copies_lock_xp );
+
+#if DEBUG_PROCESS_FD_REMOVE
+cycle = (uint32_t)hal_get_cycles();
+if( DEBUG_PROCESS_FD_REMOVE < cycle )
+printk("\n[%s] thread[%x,%x] exit for fdid %d in process %x / cycle %d\n",
+__FUNCTION__, this->process->pid, this->trdid, fdid, pid, cycle );
+#endif
+
+}  // end process_fd_remove()
 
 ////////////////////////////////////////////////
Index: /trunk/kernel/kern/process.h
===================================================================
--- /trunk/kernel/kern/process.h	(revision 656)
+++ /trunk/kernel/kern/process.h	(revision 657)
@@ -4,5 +4,5 @@
  * Authors  Ghassan Almaless (2008,2009,2010,2011,2012)
  *          Mohamed Lamine Karaoui (2015)
- *          Alain Greiner (2016,2017,2018,2019)
+ *          Alain Greiner (2016,2017,2018,2019,2020)
  *
  * Copyright (c) UPMC Sorbonne Universites
@@ -70,6 +70,6 @@
 /*********************************************************************************************
  * This structure defines an array of extended pointers on the open file descriptors
- * for a given process. We use an extended pointer because the open file descriptor
- * is always stored in the same cluster as the inode associated to the file.
+ * for a given process. We use an extended pointer because the open file descriptors
+ * are always stored in the same cluster as the inode associated to the file.
  * A free entry in this array contains the XPTR_NULL value.
  * The array size is defined by the CONFIG_PROCESS_FILE_MAX_NR parameter.
@@ -79,7 +79,9 @@
  *       - the fd_array[] in a process copy is simply a cache containing a subset of the
  *         open files to speed the fdid to xptr translation, but the "lock" and "current
- *         fields are not used.
- *       - all modifications made by the process_fd_remove() are done in reference cluster
- *         and reported in all process_copies.
+ *         fields are not significant for these copies.
+ *       - the modifications made by the process_fd_remove() function are done in the
+ *         reference cluster in all process_copies.
+ *       - The modifications made by the process_fd_register() function are done in the
+ *         reference cluster, and in the cluster containing the calling thread.
  ********************************************************************************************/
 
@@ -436,9 +438,9 @@
 
 /*********************************************************************************************
- * This function allocates a free slot in the fd_array of the reference process
+ * This function allocates a free slot in the fd_array of the reference process descriptor
  * identified by the <process_xp> argument, register the <file_xp> argument in the
  * allocated slot, and return the slot index in the <fdid> buffer.
- * It can be called by any thread in any cluster, because it uses remote access
- * primitives to access the reference process descriptor.
+ * Note: we must use the reference process descriptor, because the reference fd_array is
+ * contained in the reference cluster.  It can be called by any thread in any cluster.
  * It takes the lock protecting the reference fd_array against concurrent accesses.
  *********************************************************************************************
@@ -454,15 +456,15 @@
 /*********************************************************************************************
  * This function uses as many remote accesses as required, to reset an entry in fd_array[],
- * in all clusters containing a copy. The entry is identified by the <fdid> argument.
- * This function must be executed by a thread running in reference cluster, that contains
- * the complete list of process descriptors copies.
+ * identified by the <fdid> argument, in all clusters containing a copy of the 
+ * process descriptor, identified by the <process_xp> argument. 
+ * Note: we must use the owner process descriptor, because only this owner cluster contains
+ * the list of process copies. It can be called by any thread in any cluster.
  * It takes the lock protecting the reference fd_array against concurrent accesses.
- * TODO this function is not implemented yet.
  *********************************************************************************************
  * @ process  : [in] pointer on the local process descriptor.
  * @ fdid     : [in] file descriptor index in the fd_array.
  ********************************************************************************************/
-void process_fd_remove( process_t * process,
-                        uint32_t    fdid );
+void process_fd_remove( xptr_t     process_xp,
+                        uint32_t   fdid );
 
 /*********************************************************************************************
Index: /trunk/kernel/kern/rpc.c
===================================================================
--- /trunk/kernel/kern/rpc.c	(revision 656)
+++ /trunk/kernel/kern/rpc.c	(revision 657)
@@ -2,5 +2,5 @@
  * rpc.c - RPC operations implementation.
  * 
- * Author    Alain Greiner (2016,2017,2018,2019)
+ * Author    Alain Greiner (2016,2017,2018,2019,2020)
  *
  * Copyright (c)  UPMC Sorbonne Universites
@@ -59,28 +59,17 @@
     &rpc_thread_user_create_server,        // 6
     &rpc_thread_kernel_create_server,      // 7
-    &rpc_vfs_fs_update_dentry_server,      // 8
+    &rpc_undefined,                        // 8
     &rpc_process_sigaction_server,         // 9
 
-    &rpc_vfs_inode_create_server,          // 10  
-    &rpc_vfs_inode_destroy_server,         // 11  
-    &rpc_vfs_dentry_create_server,         // 12  
-    &rpc_vfs_dentry_destroy_server,        // 13  
-    &rpc_vfs_file_create_server,           // 14
-    &rpc_vfs_file_destroy_server,          // 15
-    &rpc_vfs_fs_new_dentry_server,         // 16
-    &rpc_vfs_fs_add_dentry_server,         // 17
-    &rpc_vfs_fs_remove_dentry_server,      // 18
-    &rpc_vfs_inode_load_all_pages_server,  // 19 
-
-    &rpc_undefined,                        // 20
-    &rpc_undefined,                        // 21
-    &rpc_undefined,                        // 22
-    &rpc_undefined,                        // 23
-    &rpc_mapper_sync_server,               // 24
-    &rpc_vmm_resize_vseg_server,           // 25
-    &rpc_vmm_remove_vseg_server,           // 26 
-    &rpc_vmm_create_vseg_server,           // 27
-    &rpc_vmm_set_cow_server,               // 28
-    &rpc_undefined,                        // 29
+    &rpc_undefined,                        // 10
+    &rpc_undefined,                        // 11
+    &rpc_undefined,                        // 12
+    &rpc_undefined,                        // 13
+    &rpc_undefined,                        // 14
+    &rpc_vmm_resize_vseg_server,           // 15
+    &rpc_vmm_remove_vseg_server,           // 16 
+    &rpc_vmm_create_vseg_server,           // 17
+    &rpc_vmm_set_cow_server,               // 18
+    &rpc_undefined,                        // 19
 };
 
@@ -95,28 +84,17 @@
     "THREAD_USER_CREATE",        // 6
     "THREAD_KERNEL_CREATE",      // 7
-    "VFS_FS_UPDATE_DENTRY",      // 8
+    "FBF_DISPLAY",               // 8
     "PROCESS_SIGACTION",         // 9
 
-    "VFS_INODE_CREATE",          // 10
-    "VFS_INODE_DESTROY",         // 11
-    "VFS_DENTRY_CREATE",         // 12
-    "VFS_DENTRY_DESTROY",        // 13
-    "VFS_FILE_CREATE",           // 14
-    "VFS_FILE_DESTROY",          // 15
-    "VFS_FS_NEW_DENTRY",         // 16
-    "VFS_FS_ADD_DENTRY",         // 17
-    "VFS_FS_REMOVE_DENTRY",      // 18
-    "VFS_INODE_LOAD_ALL_PAGES",  // 19
-
-    "VMM_GLOBAL_RESIZE_VSEG",    // 20
-    "VMM_GLOBAL_UPDATE_PTE",     // 21
-    "undefined_22",              // 22
-    "undefined_23",              // 23
-    "MAPPER_SYNC",               // 24
-    "undefined_25",              // 25
-    "VMM_REMOVE_VSEG",           // 26
-    "VMM_CREATE_VSEG",           // 27
-    "VMM_SET_COW",               // 28
-    "undefined_29",              // 29
+    "undefined_10",              // 10
+    "undefined_11",              // 11
+    "undefined_12",              // 12
+    "undefined_13",              // 13
+    "undefined_14",              // 14
+    "VMM_RESIZE_VSEG",           // 15
+    "VMM_REMOVE_VSEG",           // 16
+    "VMM_CREATE_VSEG",           // 17
+    "VMM_SET_COW",               // 18
+    "undefined_19",              // 19
 };
 
@@ -423,212 +401,24 @@
 
 
-/////////////////////////////////////////////////////////////////////////////////////////
-// [0]       RPC_PMEM_GET_PAGES deprecated [AG] May 2019
-/////////////////////////////////////////////////////////////////////////////////////////
-
-/*
-///////////////////////////////////////////////
-void rpc_pmem_get_pages_client( cxy_t      cxy,
-                                uint32_t   order,      // in 
-                                page_t  ** page )      // out 
-{
-#if DEBUG_RPC_PMEM_GET_PAGES
-thread_t * this = CURRENT_THREAD;
-uint32_t cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_RPC_PMEM_GET_PAGES )
-printk("\n[%s] thread[%x,%x] on core %d enter / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid, cycle );
-#endif
-
-    uint32_t responses = 1;
-
-    // initialise RPC descriptor header 
-    rpc_desc_t  rpc;
-    rpc.index     = RPC_PMEM_GET_PAGES;
-    rpc.blocking  = true;
-    rpc.rsp       = &responses;
-
-    // set input arguments in RPC descriptor 
-    rpc.args[0] = (uint64_t)order;
-
-    // register RPC request in remote RPC fifo
-    rpc_send( cxy , &rpc );
-
-    // get output arguments from RPC descriptor
-    *page = (page_t *)(intptr_t)rpc.args[1];
-
-#if DEBUG_RPC_PMEM_GET_PAGES
-cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_RPC_PMEM_GET_PAGES )
-printk("\n[%s] thread[%x,%x] on core %d exit / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid, cycle );
-#endif
-}
-
-///////////////////////////////////////////
-void rpc_pmem_get_pages_server( xptr_t xp )
-{
-#if DEBUG_RPC_PMEM_GET_PAGES
-thread_t * this = CURRENT_THREAD;
-uint32_t cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_RPC_PMEM_GET_PAGES )
-printk("\n[%s] thread[%x,%x] on core %d enter / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid, cycle );
-#endif
-
-    // get client cluster identifier and pointer on RPC descriptor
-    cxy_t        cxy  = GET_CXY( xp );
-    rpc_desc_t * desc = GET_PTR( xp );
-
-    // get input arguments from client RPC descriptor
-    uint32_t order = (uint32_t)hal_remote_l64( XPTR( cxy , &desc->args[0] ) );
-    
-    // call local pmem allocator
-    page_t * page = ppm_alloc_pages( order ); 
-
-    // set output arguments into client RPC descriptor
-    hal_remote_s64( XPTR( cxy , &desc->args[1] ) , (uint64_t)(intptr_t)page );
-
-#if DEBUG_RPC_PMEM_GET_PAGES
-cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_RPC_PMEM_GET_PAGES )
-printk("\n[%s] thread[%x,%x] on core %d exit / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid, cycle );
-#endif
-}
-*/
-
-/////////////////////////////////////////////////////////////////////////////////////////
-// [1]       RPC_PMEM_RELEASE_PAGES deprecated [AG] may 2019
-/////////////////////////////////////////////////////////////////////////////////////////
-
-/*
-//////////////////////////////////////////////////
-void rpc_pmem_release_pages_client( cxy_t     cxy,
-                                    page_t  * page )      // out 
-{
-#if DEBUG_RPC_PMEM_RELEASE_PAGES
-thread_t * this = CURRENT_THREAD;
-uint32_t cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_RPC_PMEM_RELEASE_PAGES )
-printk("\n[%s] thread[%x,%x] on core %d enter / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid , cycle );
-#endif
-
-    uint32_t responses = 1;
-
-    // initialise RPC descriptor header 
-    rpc_desc_t  rpc;
-    rpc.index    = RPC_PMEM_RELEASE_PAGES;
-    rpc.blocking = true;
-    rpc.rsp      = &responses;
-
-    // set input arguments in RPC descriptor 
-    rpc.args[0] = (uint64_t)(intptr_t)page;
-
-    // register RPC request in remote RPC fifo
-    rpc_send( cxy , &rpc );
-
-#if DEBUG_RPC_PMEM_RELEASE_PAGES
-cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_RPC_PMEM_RELEASE_PAGES )
-printk("\n[%s] thread[%x,%x] on core %d exit / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid, cycle );
-#endif
-}
-
-///////////////////////////////////////////////
-void rpc_pmem_release_pages_server( xptr_t xp )
-{
-#if DEBUG_RPC_PMEM_RELEASE_PAGES
-thread_t * this = CURRENT_THREAD;
-uint32_t cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_RPC_PMEM_RELEASE_PAGES )
-printk("\n[%s] thread[%x,%x] on core %d enter / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid , cycle );
-#endif
-
-    // get client cluster identifier and pointer on RPC descriptor
-    cxy_t        cxy  = GET_CXY( xp );
-    rpc_desc_t * desc = GET_PTR( xp );
-
-    // get input arguments from client RPC descriptor
-    page_t * page = (page_t *)(intptr_t)hal_remote_l64( XPTR( cxy , &desc->args[0] ) );
-    
-    // release memory to local pmem 
-    kmem_req_t req;
-    req.type = KMEM_PPM;
-    req.ptr  = page;
-    kmem_free( &req );
-
-#if DEBUG_RPC_PMEM_RELEASE_PAGES
-cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_RPC_PMEM_RELEASE_PAGES )
-printk("\n[%s] thread[%x,%x] on core %d exit / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid, cycle );
-#endif
-}
-*/
-
-/////////////////////////////////////////////////////////////////////////////////////////
-// [2]          RPC_PPM_DISPLAY deprecated [AG] May 2019    
-/////////////////////////////////////////////////////////////////////////////////////////
-
-/*
-/////////////////////////////////////////
-void rpc_ppm_display_client( cxy_t  cxy )
-{
-#if DEBUG_RPC_PPM_DISPLAY
-thread_t * this = CURRENT_THREAD;
-uint32_t cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_RPC_PPM_DISPLAY )
-printk("\n[%s] thread[%x,%x] on core %d enter / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid , cycle );
-#endif
-
-    uint32_t responses = 1;
-
-    // initialise RPC descriptor header 
-    rpc_desc_t  rpc;
-    rpc.index    = RPC_PPM_DISPLAY;
-    rpc.blocking = true;
-    rpc.rsp      = &responses;
-
-    // register RPC request in remote RPC fifo
-    rpc_send( cxy , &rpc );
-
-#if DEBUG_RPC_PPM_DISPLAY
-cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_RPC_PPM_DISPLAY )
-printk("\n[%s] thread[%x,%x] on core %d exit / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid, cycle );
-#endif
-}
-
-////////////////////////////////////////////////////////////////////
-void rpc_ppm_display_server( xptr_t __attribute__((__unused__)) xp )
-{
-#if DEBUG_RPC_PPM_DISPLAY
-thread_t * this = CURRENT_THREAD;
-uint32_t cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_RPC_PPM_DISPLAY )
-printk("\n[%s] thread[%x,%x] on core %d enter / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid , cycle );
-#endif
-
-    // call local kernel function
-    ppm_display();
-
-#if DEBUG_RPC_PPM_DISPLAY
-cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_RPC_PPM_DISPLAY )
-printk("\n[%s] thread[%x,%x] on core %d exit / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid, cycle );
-#endif
-}
-*/
-
-/////////////////////////////////////////////////////////////////////////////////////////
-// [3]           Marshaling functions attached to RPC_PROCESS_MAKE_FORK 
+/***************************************************************************************/
+/************ Marshaling functions ordered by increasing index *************************/
+/***************************************************************************************/
+
+
+/////////////////////////////////////////////////////////////////////////////////////////
+// [0]           undefined                                               
+/////////////////////////////////////////////////////////////////////////////////////////
+
+/////////////////////////////////////////////////////////////////////////////////////////
+// [1]           undefined                                               
+/////////////////////////////////////////////////////////////////////////////////////////
+
+/////////////////////////////////////////////////////////////////////////////////////////
+// [2]           undefined                                               
+/////////////////////////////////////////////////////////////////////////////////////////
+
+
+/////////////////////////////////////////////////////////////////////////////////////////
+// [3]           Marshaling function attached to RPC_MAKE_FORK           
 /////////////////////////////////////////////////////////////////////////////////////////
 
@@ -1073,87 +863,6 @@
 
 /////////////////////////////////////////////////////////////////////////////////////////
-// [8]   Marshaling functions attached to RPC_VFS_FS_UPDATE_DENTRY
-/////////////////////////////////////////////////////////////////////////////////////////
-
-/////////////////////////////////////////////////////////
-void rpc_vfs_fs_update_dentry_client( cxy_t          cxy,
-                                      vfs_inode_t  * inode,
-                                      vfs_dentry_t * dentry,
-                                      uint32_t       size,
-                                      error_t      * error )
-{
-#if DEBUG_RPC_VFS_FS_UPDATE_DENTRY
-thread_t * this = CURRENT_THREAD;
-uint32_t cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_RPC_VFS_FS_UPDATE_DENTRY )
-printk("\n[%s] thread[%x,%x] on core %d enter / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid , cycle );
-#endif
-
-    uint32_t responses = 1;
-
-    // initialise RPC descriptor header 
-    rpc_desc_t  rpc;
-    rpc.index    = RPC_VFS_FS_UPDATE_DENTRY;
-    rpc.blocking = true;
-    rpc.rsp      = &responses;
-
-    // set input arguments in RPC descriptor 
-    rpc.args[0] = (uint64_t)(intptr_t)inode;
-    rpc.args[1] = (uint64_t)(intptr_t)dentry;
-    rpc.args[2] = (uint64_t)size;
-
-    // register RPC request in remote RPC fifo
-    rpc_send( cxy , &rpc );
-
-    // get output values from RPC descriptor
-    *error   = (error_t)rpc.args[3];
-
-#if DEBUG_RPC_VFS_FS_UPDATE_DENTRY
-cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_RPC_VFS_FS_UPDATE_DENTRY )
-printk("\n[%s] thread[%x,%x] on core %d exit / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid , cycle );
-#endif
-}
-
-/////////////////////////////////////////////////
-void rpc_vfs_fs_update_dentry_server( xptr_t xp )
-{
-#if DEBUG_RPC_VFS_FS_UPDATE_DENTRY
-thread_t * this = CURRENT_THREAD;
-uint32_t cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_RPC_VFS_FS_UPDATE_DENTRY )
-printk("\n[%s] thread[%x,%x] on core %d enter / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid , cycle );
-#endif
-
-    error_t        error;
-    vfs_inode_t  * inode;
-    vfs_dentry_t * dentry;
-    uint32_t       size;
-
-    // get client cluster identifier and pointer on RPC descriptor
-    cxy_t        client_cxy  = GET_CXY( xp );
-    rpc_desc_t * desc        = GET_PTR( xp );
-
-    // get input arguments
-    inode  = (vfs_inode_t*)(intptr_t) hal_remote_l64(XPTR(client_cxy , &desc->args[0]));
-    dentry = (vfs_dentry_t*)(intptr_t)hal_remote_l64(XPTR(client_cxy , &desc->args[1]));
-    size   = (uint32_t)               hal_remote_l64(XPTR(client_cxy , &desc->args[2]));
-
-    // call the kernel function
-    error = vfs_fs_update_dentry( inode , dentry , size );
-
-    // set output argument
-    hal_remote_s64( XPTR( client_cxy , &desc->args[3] ) , (uint64_t)error );
-
-#if DEBUG_RPC_VFS_FS_UPDATE_DENTRY
-cycle = (uint32_t)hal_get_cycles();
-if( cycle > DEBUG_RPC_VFS_FS_UPDATE_DENTRY )
-printk("\n[%s] thread[%x,%x] on core %d exit / cycle %d\n",
-__FUNCTION__, this->process->pid, this->trdid, this->core->lid , cycle );
-#endif
-}
+// [8]      undefined
+/////////////////////////////////////////////////////////////////////////////////////////
 
 /////////////////////////////////////////////////////////////////////////////////////////
@@ -1197,5 +906,5 @@
 process_action_str( action ), pid, cycle );
 #endif
-}  // end rpc_process_sigaction_client() 
+}
 
 //////////////////////////////////////////////
